C==================================================================
C ROUTINE TO CREATE A LOCALLY CONNECTED SET WHICH THEN WILL BE 
C PASSED ON TO PARSE CONNLIST
c==================================================================

      SUBROUTINE LOCALSET(natot,ICLUS,ATCLUS,CLUSAT,CLUSATOM,NCS,LOCSET
     &                    ,NLSET,NLSETAT,nlstart,ATSET,CONNLIST,NCONNS,
     &                    COO1,COO2,GRDSIZE,IGRID1,IGRIDAT1,GMAX1,
     &                    LOCALOK)

      
      
      IMPLICIT NONE
      
      INCLUDE 'DynDom.param'     

      INTEGER ICLUS,ICLUSAT,NCS,NATOT
      INTEGER IAT,JAT,KAT,NLSETAT(NLOCSETMX),NCONNS
      INTEGER NLSET,ATSET(NUMATMX),ISET,JSET
      INTEGER LOCSET(NLOCSETMX,NUMATMX)      
      INTEGER CONNLIST(2,NCONNMX),NLSTART
      INTEGER IX,IY,IZ,X,Y,Z,GMAX1(3),CUR_LSET
      INTEGER IGRID1(0:NGRIDMX,0:NGRIDMX,
     &        0:NGRIDMX)
      INTEGER IGRIDAT1(0:NGRIDMX,0:NGRIDMX,
     &        0:NGRIDMX,2*GRDATMX),ATCLUS(NUMATMX)
      INTEGER CLUSATOM(NCLUSMX,NUMATMX),CLUSAT(NCLUSMX)
      REAL*8  COO1(3,NUMATMX),COO2(3,NUMATMX),DIST1,GRDSIZE
      LOGICAL CON1,CONIJ,SEEN,CONNTABLE1(NLOCSETMX,NLOCSETMX)
      LOGICAL LOCALOK     
C  
C==============================================
C INITILAISATION
       LOCALOK=.TRUE. 
       CONIJ=.FALSE. 
       NLSTART=NLSET+1       
       DO ISET=1,NLOCSETMX        
         DO IAT=1,NATOT
          LOCSET(ISET,IAT)=0
	 END DO 
	 NLSETAT(ISET)=0
        DO JSET=1,NLOCSETMX
	   CONNTABLE1(ISET,JSET)=.FALSE.
	END DO
       END DO   
C===================================================
C CREATE A LOCAL SET 
C----------------------------------------------------       
       DO ICLUSAT=1,CLUSAT(ICLUS)
           IAT=CLUSATOM(ICLUS,ICLUSAT)
           SEEN=.FALSE.
	   CUR_LSET=0     
	   IX=COO1(1,IAT)/GRDSIZE
	   IY=COO1(2,IAT)/GRDSIZE
	   IZ=COO1(3,IAT)/GRDSIZE
C
	   DO  X=IX-1,IX+1
	    DO  Y=IY-1,IY+1
	     DO  Z=IZ-1,IZ+1
C	     
	      IF (X .GT. GMAX1(1) .OR. X .LT. 0) GO TO 1
	      IF (Y .GT. GMAX1(2) .OR. Y .LT. 0) GO TO 1
	      IF (Z .GT. GMAX1(3) .OR. Z .LT. 0) GO TO 1
	      IF (IGRID1(X,Y,Z) .EQ. 0 )GO TO 1
C	      
	       DO JAT= 1,IGRID1(X,Y,Z)
	          KAT=IGRIDAT1(X,Y,Z,JAT)
		IF (IAT.NE.KAT .AND. ATCLUS(KAT).EQ.ATCLUS(IAT)) THEN
		     CALL POINTDIST(IAT,KAT,COO1,ATDISTCRIT,DIST1,CON1)
		  IF (CON1) THEN
		     IF (.NOT. SEEN .AND. ATSET(KAT) .NE. 0) THEN
                        CUR_LSET=ATSET(KAT) 
	    	        ATSET(IAT)=CUR_LSET
 		        NLSETAT(CUR_LSET)=NLSETAT(CUR_LSET)+1 
 		        LOCSET(ATSET(KAT),NLSETAT(ATSET(KAT)))=IAT
                        SEEN=.TRUE. 
		     ELSEIF(SEEN .AND. ATSET(KAT) .NE. 0 .AND.
     &                   ATSET(KAT).NE. CUR_LSET) THEN
		      IF (.NOT. CONNTABLE1(ATSET(KAT),CUR_LSET)) THEN
		      END IF
                         CONNTABLE1(CUR_LSET,ATSET(KAT))=.TRUE.
                     END IF
                      CON1=.FALSE.					 		     
		  END IF
		END IF 
2               CONTINUE 		
	       END DO
1             CONTINUE	       
C
	     END DO
	    END DO
	   END DO 
C	   
         IF ( ATSET(IAT) .EQ. 0) THEN 
	   IF (NLSET .GE. NLOCSETMX) THEN
	    WRITE(6,*)'NUMBER OF LOCAL SET EXCEEDS THE LIMIT ',NLSET
	    WRITE(6,*)'EXITING FROM  LOCALSET ROUTINE  '
	    LOCALOK=.FALSE.
	    RETURN
	   END IF 
C	   
	    NLSET=NLSET+1
	    NLSETAT(NLSET)=1
	    LOCSET(NLSET,NLSETAT(NLSET))=IAT
	    ATSET(IAT)=NLSET	    
	 END IF
C	 
       END DO
C-----------------------------------------------------------------------
       NCONNS=0        
	  DO JSET=NLSTART,NLSET
	   DO ISET=NLSTART,NLSET
   	     CONIJ=.FALSE.
C	  
            IF (CONNTABLE1(ISET,JSET))THEN
	        CONIJ=.TRUE.
	        NCONNS=NCONNS+1
C		
		IF (NCONNS .GT. NCONNMX ) THEN
		 WRITE(6,*)' LIMIT FOR NUMBER OF CONNECTIONS EXCEEDED '
		 WRITE(6,*)' CHANGE THE NCONNMX PARAMETER '		 
		 WRITE(6,*)' RETURNING FROM  LOCALSET  '
		 LOCALOK=.FALSE.
		 RETURN		 
		END IF 
C		
	        CONNLIST(1,NCONNS)=ISET
		CONNLIST(2,NCONNS)=JSET
	     END IF
C	     
	     IF (.NOT. CONIJ .AND. CONNTABLE1(JSET,ISET)) THEN
	       NCONNS=NCONNS+1
		IF (NCONNS .GT. NCONNMX ) THEN
		 WRITE(6,*)' LIMIT FOR NUMBER OF CONNECTIONS EXCEEDED '
		 WRITE(6,*)' CHANGE THE NCONNMX PARAMETER '		 
		 WRITE(6,*)' RETURNING FROM  LOCALSET  '
		 LOCALOK=.FALSE.
		 RETURN
		END IF 
C	       
	         CONNLIST(1,NCONNS)=ISET
	         CONNLIST(2,NCONNS)=JSET
	    END IF
	  END DO 
	END DO
     
        RETURN       
        END

C-------------------------------------------------------------
C
C                       
C     COPYRIGHT BY STEVEN HAYWARD ET AL., 2007.
C     CONNECTING SET
C
C-------------------------------------------------------------
