CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
       SUBROUTINE    UNIQUE(MATRIX,N_COLS,MAX_N_COLS)
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  This subroutine takes an integer matrix with two rows and eliminates 
C  redundant columns entries ( i.e. the matrix must be declared in the 
C  calling routine as MATRIX(2,N_COL_MAX) ).  The logic assumes that the 
C  matrix has been sorted so that the redundancies appear exclusively in 
C  adjacent columns.
C
       IMPLICIT       NONE
       INTEGER        MAX_N_COLS
       INTEGER        MATRIX(2,MAX_N_COLS)
       INTEGER        N_COLS
       INTEGER        I,LAST_VAL_1,LAST_VAL_2,SHIFT
       SHIFT=0
       LAST_VAL_1=MATRIX(1,1)
       LAST_VAL_2=MATRIX(2,1)
       DO I=2,N_COLS
          IF ((MATRIX(1,I).EQ.LAST_VAL_1)
     &                  .AND.(MATRIX(2,I).EQ.LAST_VAL_2)) THEN
             SHIFT=SHIFT+1
          ELSE
             LAST_VAL_1=MATRIX(1,I)
             LAST_VAL_2=MATRIX(2,I)
             IF (SHIFT.GE.1) THEN
                MATRIX(1,(I-SHIFT))=MATRIX(1,I)
                MATRIX(2,(I-SHIFT))=MATRIX(2,I)
             END IF
          END IF
       END DO
       N_COLS=N_COLS-SHIFT
       RETURN
       END
C
C       
